Change log
====

1.1.1
----
Released on 2019-04-17.

- Fixes a bug in the code that reads signed 32-bit integers.
- Allows variables defined with {RPicSim::Sim#def_var} to overlap.

1.1.0
----
Released on 2015-07-27.

- Added support for MPLAB X v3.05.  This version also works with MPLAB X v3.10, which was released later.

1.0.0
----
Released on 2014-09-17.

- Major improvements to the documentation.  Mainly, the public API of RPicSim has been defined, and everything not in the public API is now hidden from the documentation.  Doing this allows us to follow [Semantic Versioning](http://semver.org/spec/v2.0.0.html) from now on.
- MemoryWatcher: Adds WREG and BSR to the default list of registers to ignore.
- Removed all disassembly and static analysis features, since they could be better implemented in a different gem that doesn't depend on any Microchip code:
    - Removed RPicSim::ProgramFile#instruction
    - Removed RPicSim::CallStackInfo
    - Removed RPicSim::Instruction

0.4.0
----
Released on 2014-07-30.

- Adds {RPicSim::Memory#read_bytes} and {RPicSim::Memory#write_bytes}.
- Adds {RPicSim::Sim#stack_memory}.
- Fixes a bug in the RSpec 3.x support that was breaking the informative error messages when an example fails.
- Adds the ability to define symbols used in your simulation from sources other than a the COF file.
    - Adds {RPicSim::Sim::ClassDefinitionMethods#import_symbols}, which calls {RPicSim::ProgramFile#import_symbols}
    - Adds {RPicSim::Sim::ClassDefinitionMethods#def_symbol}, which calls {RPicSim::ProgramFile#def_symbol}
    - Adds {RPicSim::ProgramFile#symbols} so you can more easily debug symbol-related problems and get access to symbols even if RPicSim does not recognize what type they are.
- Adds the {RPicSim::Xc8SymFile} class, which can load symbols from a SYM file produced by the XC8 compiler and then be passed to {RPicSim::Sim::ClassDefinitionMethods#import_symbols import_symbols}.  This was necessary because the COF files produced by XC8 are difficult to interpret and do not always allow us to tell what memory space a given symbol is for.
- {RPicSim::Sim::ClassMethods#label #label} and {RPicSim::Sim::ClassMethods#labels #labels} methods are now available on both instances of a simulation class or on a simulation class itself.

MPLAB X v2.15 and v2.20 were released after RPicSim 0.4.0, but the changes in those versions of MPLAB X were minor enough that RPicSim 0.4.0 should work with them.

0.3.0
----
Released on 2014-06-20.

- Adds support for RSpec 3.x.  This release was tested with RSpec 2.14.1, 2.99.0, and 3.0.0.
- Adds support for MPLAB X 2.10.

0.2.5
----
Released on 2014-05-02.

- {RPicSim::Sim#stack_push} and {RPicSim::Sim#return} now update the TOSU, TOSH, and TOSL registers if they exist.
  This fixes bugs that were happening when using those methods in PIC18 simulations.
- Added recognition for more types of symbols found in XC8-generated COF files, but there are still issues with proper identification of variables in programs compiled with XC8.

0.2.4
----
Released on 2014-03-17.

- Added code for recognizing more types of symbols from XC8.  The XC8 symbols are more complicated than I previously thought.

0.2.3
----
Released on 2014-03-17.

- Fixed a bug preventing symbols in RAM generated by the XC8 compiler from being recognized.

0.2.2
----
Released on 2014-03-07.

- Fixed a bug in {RPicSim::Sim#new_ram_watcher} that prevented it from working.

0.2.1
----

Released on 2014-03-07.

- This release includes many, many breaking changes.

0.1.0
----

Released on 2014-02-12.
This is the initial release.
There are still some major things missing from this version that need to be added before we release 1.0.0.
Until 1.0.0 is released, we will not worry about backwards compatibility or writing complete change logs.
