RPicSim manual
====

This is the table of contents for the RPicSim manual.

* Overview
    * {file:Introduction.md}
    * {file:ChangeLog.md Change log}
    * {file:QuickStartGuide.md Quick-start guide}
    * {file:SupportedDevices.md Supported devices}
    * {file:SupportedCompilers.md Supported compilers}
    * {file:SupportedMPLABXVersions.md Supported MPLAB X versions}
    * {file:SupportedOperatingSystems.md Supported operating systems}
* Basic usage
    * {file:IntroductionToRuby.md Introduction to Ruby}
    * {file:DefiningSimulationClass.md Defining your simulation class}
    * {file:Pins.md}
    * {file:Labels.md}
    * {file:Running.md Running the simulation}
    * {file:Variables.md}
    * {file:Memories.md}
    * {file:RamWatcher.md RAM watcher}
* Testing firmware with RPicSim and RSpec
    * {file:IntroductionToRSpec.md Introduction to RSpec}
    * {file:UnitTesting.md Unit testing}
    * {file:IntegrationTesting.md Integration testing}
    * {file:RSpecIntegration.md RSpec integration}
    * {file:PersistentExpectations.md Persistent expectations}
* Tips
    * {file:Stubbing.md}
    * {file:MakingTestsRunFaster.md Making tests run faster}
    * {file:Debugging.md}
* More about RPicSim
    * {file:HowMPLABXIsFound.md How MPLAB X is Found}
    * {file:KnownIssues.md Known issues}
    * {file:DesignDecisions.md Design decisions}
    * {file:Contributing.md}